import { EventEmitter, OnChanges, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { FlexyTreeModelNode } from '../models/tree-model-node.model';
import { TreeNode } from '../models/tree-node.model';
import { FlexyTreeService } from '../services/tree.service';
export declare class FlexyTreeComponent implements OnInit, OnDestroy, OnChanges {
    private treeService;
    tree: FlexyTreeModelNode[];
    selectedId: number;
    readonlyId: number;
    templateRef: TemplateRef<any>;
    selected: EventEmitter<FlexyTreeModelNode>;
    nodes: TreeNode[];
    private selectedSubscription;
    constructor(treeService: FlexyTreeService);
    ngOnChanges(changes: any): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    private prepareItems;
    private findSelectedInChildren;
}
