import { OnInit } from '@angular/core';
import { SelectOption } from '@ng-flexy/form';
import { CdkDragDrop } from '@angular/cdk/drag-drop';
import { FormControl } from '@angular/forms';
export declare class FlexyControlDraggableSelectComponent implements OnInit {
    control: FormControl;
    default: string;
    options: SelectOption[];
    placeholder: string;
    hideSelected: boolean;
    enableSearchByValue: boolean;
    readonly: boolean;
    optionsMap: {
        [value: string]: string;
    };
    showSelect: boolean;
    ngOnInit(): void;
    drop(event: CdkDragDrop<any>): void;
    removeItem(index: number): void;
    isDraggable(): boolean;
}
