import { EventEmitter, OnInit } from '@angular/core';
import { FormControl } from '@angular/forms';
import { SelectOption, SelectOptionData } from '@ng-flexy/form';
export declare class FlexyControlSelectComponent implements OnInit {
    control: FormControl;
    options: SelectOption[];
    default: string;
    readonly: boolean;
    focused: EventEmitter<Event>;
    clicked: EventEmitter<Event>;
    changed: EventEmitter<Event>;
    optionsData: SelectOptionData[];
    ngOnInit(): void;
    onChanged(data: SelectOptionData): void;
    getOptionText(value: any): string;
}
