import { ApplicationRef, ChangeDetectorRef, OnInit } from '@angular/core';
import { FlexyFormFieldLayoutSchema } from '@ng-flexy/form';
import { SelectOption } from '@ng-flexy/form';
import { HttpClient } from '@angular/common/http';
import { FlexyLoggerService } from '@ng-flexy/core';
export declare class FlexyFormSelect2Component implements OnInit {
    private httpClient;
    private logger;
    private cdr;
    private appRef;
    layoutSchema: FlexyFormFieldLayoutSchema;
    default: string;
    label: string;
    description: string;
    placeholder: string;
    labelIcon: string;
    enableSearchByValue: boolean;
    options: SelectOption[];
    optionsUrl: string;
    optionsMapper: {
        value: string;
        text: string;
        prefixHtml?: string;
    };
    prefix: string;
    suffix: string;
    readonly: boolean;
    multiple: boolean;
    addItem: boolean;
    hideSelected: boolean;
    loading: boolean;
    constructor(httpClient: HttpClient, logger: FlexyLoggerService, cdr: ChangeDetectorRef, appRef: ApplicationRef);
    ngOnInit(): void;
    private mapper;
}
