import { OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { TreeNode } from '../models/tree-node.model';
import { FlexyTreeService } from '../services/tree.service';
export declare class FlexyTreeNodeComponent implements OnInit, OnDestroy {
    private treeService;
    nodes: TreeNode[];
    templateRef: TemplateRef<any>;
    private _subscription;
    constructor(treeService: FlexyTreeService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    toggleExpand(leaf: TreeNode): void;
    toggleSelected(node: TreeNode): void;
}
