import { EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { FormBuilder, FormControl, FormGroup } from '@angular/forms';
import { SelectOption } from '@ng-flexy/form';
export declare class FlexyControlCheckboxListComponent implements OnInit, OnDestroy {
    private formBuilder;
    control: FormControl;
    name: string;
    default: string[];
    options: SelectOption[];
    readonly: boolean;
    changed: EventEmitter<string[]>;
    localGroupControl: FormGroup;
    valuesLabels: string;
    defaultsLabels: string;
    private controlChangesSubscription;
    private localValuesChangesSubscription;
    constructor(formBuilder: FormBuilder);
    ngOnInit(): void;
    ngOnDestroy(): void;
    private initCheckboxesGroup;
    private subscribeLocalChanges;
    private setDefaultsLabels;
    private setValueLabels;
    private updateControl;
}
