import { EventEmitter, OnChanges, OnInit } from '@angular/core';
import { FormControl } from '@angular/forms';
import { SelectOption, SelectOptionData } from '@ng-flexy/form';
export declare class FlexyControlSelect2Component implements OnInit, OnChanges {
    control: FormControl;
    options: SelectOption[];
    default: string;
    readonly: boolean;
    multiple: boolean;
    addItem: boolean;
    placeholder: string;
    hideSelected: boolean;
    enableSearchByValue: boolean;
    loading: boolean;
    loadingText: string;
    focused: EventEmitter<Event>;
    clicked: EventEmitter<Event>;
    changed: EventEmitter<any>;
    virtualScroll: boolean;
    optionsData: SelectOptionData[];
    ngOnInit(): void;
    ngOnChanges(changes: any): void;
    onChange(data: SelectOptionData | SelectOptionData[]): void;
    getReadonlyInfo(value: any): string;
    customSearchFn(term: string, item: SelectOption): any;
}
